# Copyright (C) 2004-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

# * The software is provided "as is" without any warranty, neither express
#   nor implied.
# * In no event will the author be held liable for any damage(s) arising
#   from the use of the software.
# * Redistribution of the software is allowed only in unmodified form.
# * Permission is granted to use the software solely for personal private
#   and non-commercial purposes.
# * An individuals use of the software in his or her capacity or function
#   as an agent, (independent) contractor, employee, member or officer of
#   a business, corporation or organization (commercial or non-commercial)
#   does not qualify as personal private and non-commercial purpose.
# * Without written approval from the author the software must not be used
#   for a business, for commercial, corporate, governmental, military or
#   organizational purposes of any kind, or in a commercial, corporate,
#   governmental, military or organizational environment of any kind.

.SUFFIXES:

offender: OFFENDER.COM OFFENDER.DLL OFFENDER.EXE
	"$(MAKEDIR)\OFFENDER.COM"
	CONTROL.EXE "$(MAKEDIR)\OFFENDER.DLL"
	"$(MAKEDIR)\OFFENDER.EXE" $?

clobber: clean
	Erase OFFENDER.COM OFFENDER.DLL OFFENDER.EXE

clean:
	Erase OFFENDER.OBJ

cabinet: OFFENDER.CAB
	SIGNTOOL.EXE Sign /A /D "eSKamation Defender Exploits" /DU "https://skanthak.hier-im-netz.de/offender.html" /N "Stefan Kanthak" /T "http://timestamp.digicert.com/" /V $**
#	SIGNTOOL.EXE Sign /AS /D "eSKamation Defender Exploits" /DU "https://skanthak.hier-im-netz.de/offender.html" /FD SHA256 /N "Stefan Kanthak" /TD SHA256 /TR "http://timestamp.digicert.com/" /V $**

OFFENDER.CAB: OFFENDER.COM OFFENDER.DLL OFFENDER.EXE OFFENDER.MAK
	MAKECAB.EXE /D CabinetNameTemplate=$@ /D CompressionLevel=7 /D CompressionMemory=21 /D CompressionType=LZX /D DiskDirectoryTemplate= /D InfFileName=NUL: /D RptFileName=NUL: /F <<
OFFENDER.COM
OFFENDER.DLL
OFFENDER.EXE
<<NOKEEP

OFFENDER.OMF: OFFENDER.MAK
	ML.EXE /Brepro /Fo$@ /nologo /omf /Ta<< /W3 /X
; Copyright (C) 2004-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

	.model	tiny

e_header struct				; DOS .EXE header
e_magic	word	5A4Dh			; magic number "MZ"
e_cblp	word	stop - header		; bytes on last page of file
e_cp	word	1			; pages in file
e_crlc	word	0			; number of relocation table entries
e_cparhdr word	sizeof header / 16	; size of header in paragraphs
e_minalloc word	0			; minimum extra paragraphs needed
e_maxalloc word	65535			; maximum extra paragraphs needed
e_ss	word	0			; initial (PSP relative) SS value
e_sp	word	stack - header		; initial (SS relative) SP value
e_csum	word	0			; checksum
e_ip	word	sizeof message		; initial (CS relative) IP value
e_cs	word	0			; initial (PSP relative) CS value
e_lfarlc word	sizeof header		; file address of relocation table
e_ovno	word	0			; overlay number
e_res	word	4 dup (0)		; reserved words
e_oemid	word	5719h			; OEM identifier
e_oeminfo word	2704h			; OEM information
e_res2	word	10 dup (0)		; reserved words
e_lfanew dword	0			; file address of new exe header
e_header ends

	.code

header	e_header <>

message	byte	"(C)opyright 2004-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>", 0Dh, 0Ah, 07h, 24h

start:
	push	cs
	pop	ds
	xor	dx, dx
	mov	ah, 09h
	int	21h

	mov	ax, 4C01h
	int	21h
stop:
	dword	20 dup (?)
stack:
	end	start
<<NOKEEP

OFFENDER.COM: OFFENDER.MAK
	CERTUTIL.EXE /DecodeHex /F /V << $@
4D 5A 90 00 01 00 00 00 04 00 00 00 FF FF 00 00   MZ..............
E0 00 00 00 43 00 00 00 40 00 00 00 00 00 00 00   ....C...@.......
00 00 00 00 19 57 04 27 00 00 00 00 00 00 00 00   .....W.'........
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00   ................
28 43 29 6F 70 79 72 69 67 68 74 20 32 30 30 34   (C)opyright 2004
2D 32 30 32 34 2C 20 53 74 65 66 61 6E 20 4B 61   -2024, Stefan Ka
6E 74 68 61 6B 20 3C 73 74 65 66 61 6E 2E 6B 61   nthak <stefan.ka
6E 74 68 61 6B 40 6E 65 78 67 6F 2E 64 65 3E 0D   nthak@nexgo.de>.
0A 07 24 0E 1F 33 D2 B4 09 CD 21 B8 01 4C CD 21   .....3....!..L.!
<<NOKEEP

OFFENDER.DLL: OFFENDER.COM OFFENDER.OBJ
	LINK.EXE /LINK /ALLOWBIND:NO /BREPRO /DEFAULTLIB:KERNEL32.LIB /DEFAULTLIB:USER32.LIB /DLL /DYNAMICBASE /ENTRY:_DllMainCRTStartup /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OPT:ICF,REF /OSVERSION:5.1 /OUT:$@ /RELEASE /STUB:OFFENDER.COM /SUBSYSTEM:WINDOWS /SWAPRUN:CD,NET /TEST /VERSION:0.815 OFFENDER.OBJ

OFFENDER.EXE: OFFENDER.COM OFFENDER.OBJ
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:KERNEL32.LIB /DEFAULTLIB:USER32.LIB /DYNAMICBASE /ENTRY:wWinMainCRTStartup /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OPT:ICF,REF /OSVERSION:5.1 /OUT:$@ /RELEASE /STUB:OFFENDER.COM /SUBSYSTEM:WINDOWS /SWAPRUN:CD,NET /TEST /VERSION:0.815 OFFENDER.OBJ

OFFENDER.OBJ: OFFENDER.MAK
	CL.EXE /Brepro /c /Fo$@ /GA /GF /Gw /Gy /nologo /Ox /Tc<< /W4 /wd4100 /we4013 /Zl
// Copyright (C) 2004-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

#define STRICT
#define UNICODE
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

const	LPCWSTR	szReason[] = {L"DLL_PROCESS_DETACH",
		              L"DLL_PROCESS_ATTACH",
		              L"DLL_THREAD_ATTACH",
		              L"DLL_THREAD_DETACH"};

// https://msdn.microsoft.com/en-us/library/988ye33t.aspx

BOOL	WINAPI	_DllMainCRTStartup(HANDLE hModule,
		                   DWORD  dwReason,
		                   LPVOID lpReserved)
{
	// https://msdn.microsoft.com/en-us/library/ms645507.aspx

	INT	ni = MessageBoxEx(HWND_DESKTOP,
	                          szReason[dwReason],
	                          __LPREFIX(__FUNCTION__) L"() entry point function",
	                          dwReason == DLL_PROCESS_DETACH ? MB_OK : MB_OKCANCEL,
	                          MAKELANGID(LANG_ENGLISH, SUBLANG_NEUTRAL));

	if (dwReason == DLL_PROCESS_ATTACH)
		return ni != IDCANCEL;

	if ((dwReason != DLL_PROCESS_DETACH)
	 && (ni == IDCANCEL))

		// https://msdn.microsoft.com/en-us/library/ms682579.aspx

		if (!DisableThreadLibraryCalls(hModule))

			// https://msdn.microsoft.com/en-us/library/ms683153.aspx
			// https://msdn.microsoft.com/en-us/library/ms679360.aspx

			FreeLibraryAndExitThread(hModule, GetLastError());

	return FALSE;
}

// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

__declspec(noreturn)
VOID	CDECL	wWinMainCRTStartup(VOID)
{
	// https://msdn.microsoft.com/en-us/library/ms645507.aspx
	// https://msdn.microsoft.com/en-us/library/ms683156.aspx

	INT	ni = MessageBoxEx(HWND_DESKTOP,
	                          GetCommandLine(),
	                          __LPREFIX(__FUNCTION__) L"() entry point function",
	                          MB_OK,
	                          MAKELANGID(LANG_ENGLISH, SUBLANG_NEUTRAL));

	// https://msdn.microsoft.com/en-us/library/ms682658.aspx

	ExitProcess(ni);
}
<<NOKEEP
